/*****************************************************************************
 *
 * Atmel Corporation
 *
 * ̧		: AVRInSystemProg.hpp
 * ߲	: Dev-C++ 4.9.8.0 - http://bloodshed.net/dev/
 * 		: $Revision: 1163 $
 * t		: $Date: 2008N82 15:38:16 +0200 $
 * XV	: $Author: ohlia $
 *
 * xҰ	: avr@atmel.com
 *
 * ړI	: Win32
 *
 * pLq	: AVR911 - AVRJ݊
 *
 * 		: AVR910pLqŋLqAVR ISPɑ΂̪񋟂׽B
 *			  ̸׽AVRProgrammerh܂B
 *
 ****************************************************************************/
#ifndef AVRINSYSTEMPROG_HPP
#define AVRINSYSTEMPROG_HPP

using namespace std;

#include "AVRProgrammer.hpp"
#include "Utility.hpp"

class AVRInSystemProg : public AVRProgrammer
{
	protected:
		void setAddress( long address );
		void writeFlashLowByte( long value );	// ɐɉ޲
		void writeFlashHighByte( long value );	// ̌ɏ޲
		void writeFlashPage();

	public:
		/* ݽ׸ */
		AVRInSystemProg( CommChannel * _comm );

		/* ޽׸ */
		~AVRInSystemProg();

		/* ҿ */
		virtual bool enterProgrammingMode();
		virtual bool leaveProgrammingMode();

		virtual bool chipErase();
		virtual unsigned char RC_Calibrate();
		virtual bool readOSCCAL( long pos, long * value );
		virtual bool readSignature( long * sig0, long * sig1, long * sig2 );
		virtual bool checkSignature( long sig0, long sig1, long sig2 );

		virtual bool writeFlashByte( long address, long value );
		virtual bool writeEEPROMByte( long address, long value );

		virtual bool writeFlash( HEXFile * data );
		virtual bool readFlash( HEXFile * data );

		virtual bool writeEEPROM( HEXFile * data );
		virtual bool readEEPROM( HEXFile * data );

		virtual bool writeLockBits( long bits );
		virtual bool readLockBits( long * bits );

		virtual bool writeFuseBits( long bits );
		virtual bool readFuseBits( long * bits );
		virtual bool writeExtendedFuseBits( long bits );
		virtual bool readExtendedFuseBits( long * bits );

		virtual bool programmerSoftwareVersion( long * major, long * minor );
		virtual bool programmerHardwareVersion( long * major, long * minor );
};

#endif
