/*****************************************************************************
 *
 * Atmel Corporation
 *
 * ̧		: XMLParser.cpp
 * ߲	: Dev-C++ 4.9.8.0 - http://bloodshed.net/dev/
 * 		: $Revision: 3419 $
 * t		: $Date: 2008N222 09:56:34 +0100 $
 * XV	: $Author: khole $
 *
 * xҰ	: avr@atmel.com
 *
 * ړI	: Win32
 *
 * pLq	: AVR911 - AVRJ݊
 *
 * 		: ȒPXML DOMl͕̉BXMĻق犮SȖ؍\\z
 *			  B<section/>ނx܂Aޑ͎x܂B
 *
 ****************************************************************************/
#include "XMLParser.hpp"

/* I׽ */

enum XMLNodeType
{
	xml_node,
	xml_subtree
};

/* ۸׽BXMLTreeXMLNode̸͂׽h܂B */
class XMLAbstractNode
{
	protected:
		string name;							// ̐(ɰ)̖O
		XMLNodeType type;

	public:
		/* ݽ׸ */
		XMLAbstractNode( const string & _name, XMLNodeType _type );

		/* ޽׸ */
		~XMLAbstractNode();

		/* ҿ */
		const string & getName();
		XMLNodeType getType();

		bool isName( const string & _name );	// O_nameƔr

		virtual void print() = 0;
};


/* XMLAbstractNodeh؍\Lq׽ */
class XMLTree : public XMLAbstractNode
{
	protected:
		list<XMLAbstractNode *> nodes;			// ̖؍\܂ސ(ɰ)

	public:	
		/* ݽ׸ */
		XMLTree( const string & _name );

		/* ޽׸ */
		~XMLTree();

		/* ҿ */
		void addNode( XMLAbstractNode * newnode );
		bool containsNode( const string & _name );	// listŖO
		XMLAbstractNode * getNode( const string & _name );

		void print();
};


/* XMLAbstractNodehŕ]ʏ̐(ɰ)Lq׽ */
class XMLNode : public XMLAbstractNode
{
	protected:
		string value;							// l

	public:
		/* ݽ׸ */
		XMLNode( const string & _name, const string & _value );

		/* ޽׸ */
		~XMLNode();

		/* ҿ */
		bool isEmpty();							// 󕶎܂?
		const string & getValue();

		void print();
};


void XMLFile::removeComments( string & txt )
{
	long pos = 0;							// ̓_܂ł̑SĂY

	long startFoundAt;						// ̈ʒuŌ钍߂̊Jn
	long endFoundAt;						// I

	/* SĂ̒ނĎ苎 */
	do
	{
		/* ߂̊Jn */
		startFoundAt = txt.find( "<!--", pos );

		/* ߂ȂΌJԂ𔲂o */
		if( startFoundAt == string::npos )
		{
			pos = txt.size();
			break;
		}

		/* ߂̏I */
		endFoundAt = txt.find( "-->", startFoundAt );

		/* JnL芎IȂȂAُ */
		if( endFoundAt == string::npos )
			throw new ErrorMsg( "Unclosed comment tag encountered! "
								"Comment start-tag '<!--' found, but no "
								"closing '-->'." );

		/* ނ苎 */
		txt.erase( startFoundAt, endFoundAt - startFoundAt + 3 );

		pos = startFoundAt;					// 

	} while( pos < txt.size() );
}

void XMLFile::removeStartXML( string & txt )
{
	long pos = 0;							// ̓_܂ł̑SĂY

	long startFoundAt;						// ߂̊JnƏI͂̓_Ō܂B
	long endFoundAt;

	/* <?xmlނTč폜 */
	startFoundAt = txt.find( "<?xml", pos );

	/* ȂΌJԂ𔲂 */
	if( startFoundAt == string::npos )
	{
		pos = txt.size();
		return;
	}

	/* I */
	endFoundAt = txt.find( ">", startFoundAt );

	/* ލ폜 */
	txt.erase( startFoundAt, endFoundAt - startFoundAt );
}


void XMLFile::removeAttributes( string & txt )
{
	long pos;								// ̓_܂ł̑SĂY

	long startFoundAt;						// ̈ʒuŌނ̊Jn
	long endFoundAt;						// I

	long spaceFoundAt;						// ̈ʒuł݂鑮Ő
	long slashFoundAt;						// ̈ʒuł݂I'/'

	/* PɎԂȒPɂ邽߁A]SĂ̋󔒂ɕϊ */
	for( pos = 0; pos < txt.size(); pos++ )
	{
		if( txt[pos] == '\n' || txt[pos] == '\r' || txt[pos] == '\t' )
			txt.replace( pos, 1, " " );
	}

	pos = 0;

	/* SĂނY */
	do
	{
		/* ނ̊Jn */
		startFoundAt = txt.find( "<", pos );

		/* ނȂΌJԂ𔲂o */
		if( startFoundAt == string::npos )
			break;

		/* ނ̏I */
		endFoundAt = txt.find( ">", startFoundAt );

		/* JnL芎IȂŁAُ */
		if( endFoundAt == string::npos )
			throw new ErrorMsg( "Unclosed tag encountered! "
								"Tag start token '<' found, but not "
								"closing '>'." );

		/* ޖ̗]苎 */
		while( txt[startFoundAt+1] == ' ' )
		{
			txt.erase( startFoundAt+1, 1 );	// 苎
			endFoundAt--;					// ͍k߂܂B
		}

		/* Ő󔒂 */
		spaceFoundAt = txt.find( " ", startFoundAt );
		if( spaceFoundAt < endFoundAt && spaceFoundAt != string::npos )	// ޓŋ󔒔?
		{
			/* ꂪނ */
			slashFoundAt = txt.find( "/", spaceFoundAt );
			if( slashFoundAt < endFoundAt )
			{
			// ނȂA/>/苎]݂܂B
			if ( txt.at(endFoundAt-1) == '/' )
			{
			 endFoundAt--;
			}

			/* 苎 */
			txt.erase( spaceFoundAt, endFoundAt - spaceFoundAt );
			endFoundAt -= endFoundAt - spaceFoundAt;	// ͍k߂܂B
		}

		pos = endFoundAt + 1;				// 

	} while( pos < txt.size() );
}


void XMLFile::readFile( const string & _filename )
{
	ifstream f;								// XMĻ ذ
	string contents;						// XMĻٓe
	string templine;

	/* ̧قJƂs */
	f.open( _filename.c_str(), ios::in );
	if( !f )
		throw new ErrorMsg( "Error opening XML file for input!" );

	/* eɑSĂǂݍ */
	contents.erase();
	templine.erase();
	do
	{
		contents += templine + " ";
		f >> templine;						// ͍ŌォǂގɂEOF𔭐
	} while( !f.eof() );

	f.close();

	/* ߂ޑ苎 */
	removeComments( contents );
	removeAttributes( contents );
	removeStartXML ( contents );

	/* (ɰ)쐬 */
	root = new XMLTree( "root" );
	parseFragment( contents, root );

	Util.progress( "\r\n" );				// i\I
}


void XMLFile::parseFragment( string & fragment, XMLTree * parent )
{
	long startFoundAt;						// ̈ʒuł݂ނ̊Jn
	long endFoundAt;						// ƏI

	string closingString;					// ނ̂Ɏgp錟
	long closingFoundAt;					// ̈ʒuŌ

	string tagName;							// ͍ŋߍ쐬ꂽޗp
	string tagValue;

	XMLTree * newTree;
	XMLNode * newNode;

	long nestedFoundAt;						// ̈ʒuœqɂꂽޔ

	/* ŏނ */
	Util.progress( "#" );					// i\is

	while( true )							// break҂
	{
		/* ނ̊Jn */
		startFoundAt = fragment.find( "<", 0 );
		if( startFoundAt == string::npos )	// ނȂΌJԂ𔲂o
			break;

		/* ꂪ荂قޑ΂ɑ΂ނ */
		if( fragment[startFoundAt+1] == '/' )
			break;							// JԂ𔲂o

		/* ނ̏I */
		endFoundAt = fragment.find( ">", startFoundAt );
		if( endFoundAt == string::npos )	// IȂΈُ
			throw new ErrorMsg( "Unclosed tag encountered! "
								"Tag start token '<' found, but no "
								"closing '>'." );

		/* ނ̖O𒊏o */
		tagName = fragment.substr( startFoundAt+1, endFoundAt-startFoundAt-1 );
		if( tagName.size() == 0 )			// 0ޖȂΈُ
			throw new ErrorMsg( "Unnamed tag encountered! "
								"No text between '<' and '>'." );

		/* fЂނ苎 */
		fragment.erase( 0, startFoundAt+tagName.size()+2 );

		/* ꂪނ */
		if( tagName[tagName.size()-1] == '/' )
		{
			/* V̒ʏނ쐬 */
			tagName.erase( tagName.size()-1 );	// '/'苎
			tagValue.erase();					// ނ͒l܂B
			newNode = new XMLNode( tagName, tagValue );
			parent->addNode( newNode );
		} else
		{
			/* ̑΂ɑ΂Ĉvނ */
			closingString.erase();
			closingString += "</" + tagName + ">";
			closingFoundAt = fragment.find( closingString, 0 );
			if( closingFoundAt == string::npos )	// Ȃꍇُ͈
				throw new ErrorMsg( "Closing tag not found! "
									"Opening tag '<" + tagName + ">' found, "
									"but not closing '" + closingString + "'." );

			/* ؍\AޑΓނ𒲍 */
			nestedFoundAt = fragment.find( "<", 0 );
			if( nestedFoundAt == closingFoundAt )	// ̓ނȂ?
			{
				/* ޑΓ̓e𒊏o */
				tagValue = fragment.substr( 0, closingFoundAt );

				/* Vʏނ쐬 */
				newNode = new XMLNode( tagName, tagValue );
				parent->addNode( newNode );
			} else
			{
				/* V؍\쐬Ƃ̒fЉ */
				newTree = new XMLTree( tagName );
				parent->addNode( newTree );
				parseFragment( fragment, newTree );

				/* ނ̌ł邩 */
				closingFoundAt = fragment.find( closingString, 0 );
				if( closingFoundAt == string::npos )
					throw new ErrorMsg( "Closing tag not found! "
										"Opening tag '<" + tagName + ">' found, "
										"but not closing '" + closingString + "'." );
			}

			/* fЂ̒lƕނ苎 */
			fragment.erase( 0, closingFoundAt + closingString.size() ); 
		}
	};
}


/* ݽ׸ */
XMLFile::XMLFile( const string & _filename )
{
	readFile( _filename );
}


/* ޽׸ */
XMLFile::~XMLFile()
{
	if( root != NULL )
		delete root;
}


bool XMLFile::exists( const string & path )
{
	XMLAbstractNode * currentNode = root;
	XMLTree * currentTree;
	long namePos;							// ߽݂̌ޖɑ΂ʒu
	long separatorPos;						// ޖɌ㑱#qɑ΂ʒu
	string tagName;							// ݂ޖ

	namePos = 0;

	while( true )							// ͓breakŔ܂B
	{
		/* qA܂͕̍Ōɑ΂ʒuݒ */
		separatorPos = path.find( "\\", namePos );
		if( separatorPos == string::npos )
			separatorPos = path.size();

		/* ޖoAꂪ */
		tagName = path.substr( namePos, separatorPos-namePos );
		currentTree = (XMLTree *) currentNode;	// ͖{ɖ؍\
		if( !currentTree->containsNode( tagName ) )
			return false;					// Ȃ

		currentNode = currentTree->getNode( tagName );

		/* ߽ɂޗL? */
		if( separatorPos < path.size() )
		{
			/* A݂̐(ɰ)ǂ؍\ɂȂ */
			if( currentNode->getType() != xml_subtree )
			{
				return false;				// Ȃ
			} else
			{
				namePos = separatorPos + 1;	// ߽̈ʒuis
			}
		} else
		{
			break;							// AJԂ𔲂o
		}
	}

	return true;							// !
}


const string & XMLFile::getValue( const string & path )
{
	XMLAbstractNode * currentNode = root;
	XMLTree * currentTree;
	long namePos;							// ߽݂̌ޖɑ΂ʒu
	long separatorPos;						// ޖɌ㑱#qɑ΂ʒu
	string tagName;							// ݂ޖ

	namePos = 0;

	while( true )							// ͓breakŔ܂B
	{
		/* qA܂͕̍Ōɑ΂ʒuݒ */
		separatorPos = path.find( "\\", namePos );
		if( separatorPos == string::npos )
			separatorPos = path.size();

		/* ޖoAꂪ */
		tagName = path.substr( namePos, separatorPos-namePos );
		currentTree = (XMLTree *) currentNode;	// ͖{ɖ؍\
		if( !currentTree->containsNode( tagName ) )
			throw new ErrorMsg( "Node '" + tagName + "' not found!" );

		currentNode = currentTree->getNode( tagName );

		/* ߽ɂޗL? */
		if( separatorPos < path.size() )
		{
			/* A݂̐(ɰ)ǂ؍\ɂȂ */
			if( currentNode->getType() != xml_subtree )
			{
				throw new ErrorMsg( "Illegal path: (" + path + ")!" );
			} else
			{
				namePos = separatorPos + 1;	// ߽̈ʒuis
			}
		} else
		{
			break;							// AJԂ𔲂o
		}
	}
	
	/* ݂̐(ɰ)ʏ̐߂ */
	if( currentNode->getType() != xml_node )
		throw new ErrorMsg( "Node '" + tagName + "' is not an element!" );

	return ((XMLNode *) currentNode)->getValue();
}


void XMLFile::print()
{
	root->print();
}


/* ݽ׸ */
XMLAbstractNode::XMLAbstractNode( const string & _name, XMLNodeType _type ) :
	name( _name ),
	type( _type )
{
	// ɺނȂ
}


/* ޽׸ */
XMLAbstractNode::~XMLAbstractNode()
{
	// ɺނȂ
}


const string & XMLAbstractNode::getName()
{
	return name;
}


XMLNodeType XMLAbstractNode::getType()
{
	return type;
}

	
bool XMLAbstractNode::isName( const string & _name )
{
	return (name == _name);
}


/* ݽ׸ */
XMLTree::XMLTree( const string & _name ) :
	XMLAbstractNode::XMLAbstractNode( _name, xml_subtree )
{
	// ɺނȂ
}


/* ޽׸ */
XMLTree::~XMLTree()
{
	/* listɑ΂锽q쐬 */
	list<XMLAbstractNode *>::iterator i;

	/* ܂܂SĂ̐(ɰ)j */
	for( i = nodes.begin(); i != nodes.end(); i++ )
	{
		delete (*i);
	}
}


void XMLTree::addNode( XMLAbstractNode * newnode )
{
	nodes.push_back( newnode );
}


bool XMLTree::containsNode( const string & _name )
{
	/* listɑ΂锽q쐬 */
	list<XMLAbstractNode *>::iterator i;

	/* O_nameŐ(ɰ) */
	i = nodes.begin();

	while( i != nodes.end() )
	{
		if( (*i)->isName( _name ) )
			return true;

		i++;
	}

	return false;
}


XMLAbstractNode * XMLTree::getNode( const string & _name )
{
	/* listɑ΂锽q쐬 */
	list<XMLAbstractNode *>::iterator i;

	/* O_nameŐ(ɰ) */
	i = nodes.begin();

	while( i != nodes.end() )
	{
		if( (*i)->isName( _name ) )
			return *i;

		i++;
	}

	return NULL;
}


void XMLTree::print()
{
	/* listɑ΂锽q쐬 */
	list<XMLAbstractNode *>::iterator i;

	cout << "TREE[ Name: \"" << name << "\" ]:" << endl;

	/* O_nameŐ(ɰ) */
	i = nodes.begin();

	while( i != nodes.end() )
	{
		(*i)->print();

		i++;
	}

	cout << ":END[\"" << name << "\"]" << endl;
}


/* ݽ׸ */
XMLNode::XMLNode( const string & _name, const string & _value ) :
	XMLAbstractNode::XMLAbstractNode( _name, xml_node ),
	value( _value )
{
	// ɺނȂ
}


/* ޽׸ */
XMLNode::~XMLNode()
{
	// ɺނȂ
}


bool XMLNode::isEmpty()
{
	return value.empty();
}


const string & XMLNode::getValue()
{
	return value;
}


void XMLNode::print()
{
	cout << "NODE[ Name: \"" << name << "\" Value: \"" << value << "\" ]" << endl; 
}

/* ̧ق̍Ō */
